<?php
/* --------------------------------------------------------------
   dependent.inc.php 2021-12-16
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2021 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------*/

/** @var DatabaseModel $this */
/** @var bool $t_success */

$queryIsCookieConsentInstalled = $this->query('SELECT `value` FROM `gx_configurations` WHERE `key` = "modules/GambioCookieConsentPanel/label_button_advanced_settings"');
$isCookieConsentInstalled = isset($queryIsCookieConsentInstalled[0]);

$check = $this->query('SELECT `value` FROM `gx_configurations` WHERE `key` = "modules/GambioCookieConsentPanel/label_button_only_essentials"', true);

if($isCookieConsentInstalled && $check->num_rows < 1) {
    $query     = 'INSERT INTO `gx_configurations` (`key`, `value`) VALUES (\'modules/GambioCookieConsentPanel/label_button_only_essentials\', \'{\"de\":\"Nur Notwendige\",\"en\":\"Only Essentials\"}\'), (\'modules/GambioCookieConsentPanel/only_essentials_button_status\', \'0\')';
    $t_success &= $this->query($query, true);
}

/**
 * Deleting nonexistent products that are still in the "products_properties_admin_select" table
 */
$nonExistingProducts = $this->query("SELECT DISTINCT ppas.`products_id`
                                            FROM `products_properties_admin_select` ppas
                                            LEFT JOIN `products` AS p USING (`products_id`)
                                            WHERE p.`products_id` IS NULL;");

if ($nonExistingProducts) {
    $nonExistingProductIds = implode(',', array_column($nonExistingProducts, 'products_id'));
    
    $query = "DELETE FROM `products_properties_admin_select` WHERE `products_id` IN ({$nonExistingProductIds})";
    $t_success &= $this->query($query, true);
}

/**
 * Deleting nonexistent products that are still in the "products_to_categories" table
 */
$nonExistingProducts = $this->query("SELECT DISTINCT ptc.`products_id`
                                            FROM `products_to_categories` ptc
                                            LEFT JOIN `products` AS p USING (`products_id`)
                                            WHERE p.`products_id` IS NULL;");

if ($nonExistingProducts) {
    $nonExistingProductIds = implode(',', array_column($nonExistingProducts, 'products_id'));
    
    $query = "DELETE FROM `products_to_categories` WHERE `products_id` IN ({$nonExistingProductIds})";
    $t_success &= $this->query($query, true);
}
